#include "dataset.h"

Dataset::Dataset()
{
dimension=0;
}

Dataset::Dataset(const char *filename)
{
    FILE *fp=fopen(filename,"r");
    if(!fp) return;
    int count,i,j;
    fscanf(fp,"%d",&dimension);
    fscanf(fp,"%d",&count);
    xpoint.resize(count);
    ypoint.resize(count);
    for(i=0;i<count;i++)
    {
        xpoint[i].resize(dimension);
        for(j=0;j<dimension;j++)
        {
            fscanf(fp,"%lf",&xpoint[i][j]);
        }
        fscanf(fp,"%lf",&ypoint[i]);
    }
    fclose(fp);
}

double Dataset::gety(int pos)
{
    return ypoint[pos];
}

void    Dataset::loadDefaults()
{
    //load lenses data
    dimension=4;
    xpoint.resize(24);
    xpoint[0]<<1<<2<<2<<1;
    xpoint[1]<<1<<2<<1<<1;
    xpoint[2]<<1<<2<<2<<2;
    xpoint[3]<<2<<1<<1<<2;
    xpoint[4]<<2<<1<<2<<1;
    xpoint[5]<<2<<1<<2<<2;
    xpoint[6]<<2<<2<<1<<1;
    xpoint[7]<<2<<2<<1<<2;
    xpoint[8]<<3<<1<<1<<2;
    xpoint[9]<<3<<1<<2<<1;
    xpoint[10]<<3<<1<<2<<2;
    xpoint[11]<<3<<2<<2<<1;
    xpoint[12]<<1<<1<<1<<1;
    xpoint[13]<<1<<1<<1<<2;
    xpoint[14]<<1<<1<<2<<2;
    xpoint[15]<<1<<2<<1<<2;
    xpoint[16]<<1<<2<<2<<1;
    xpoint[17]<<2<<1<<1<<1;
    xpoint[18]<<2<<2<<2<<1;
    xpoint[19]<<2<<2<<2<<2;
    xpoint[20]<<3<<1<<1<<1;
    xpoint[21]<<3<<2<<1<<1;
    xpoint[22]<<3<<2<<1<<2;
    xpoint[23]<<3<<2<<2<<2;
}

void    Dataset::normalizeZeroOne()
{
    QVector<double> max;
    QVector<double> min;
    int i,j;
    max.resize(dimension);
    max.fill(-1e+100);
    min.resize(dimension);
    min.fill(1e+100);
    for(i=0;i<xpoint.size();i++)
    {
        for(j=0;j<dimension;j++)
        {
            if(min[j]>xpoint[i][j])
                min[j]=xpoint[i][j];
            if(max[j]<xpoint[i][j])
                max[j]=xpoint[i][j];
        }
    }
    for(i=0;i<xpoint.size();i++)
    {
        for(j=0;j<dimension;j++)
        {
            xpoint[i][j]=(xpoint[i][j]-min[j])/(max[j]-min[j]);
        }
    }
}

void    Dataset::normalizeMean()
{
    //to be implemented
}
int     Dataset::getdimension() const
{
    return dimension;
}

int     Dataset::getpatterns() const
{
    return xpoint.size();
}

Data    Dataset::getpoint(int pos)
{
    return xpoint[pos];
}

Dataset::~Dataset()
{

}
